## stress-ng-0.13.05.tar.gz

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.13.05
#
# Codename "wakeboarding interstellar wombat"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
CFLAGS += -Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
endif

#
# Verbosity
#
override undefine V
ifeq ($(VERBOSE),)
V=@
Q=@
else
V=
Q=@#
endif

GREP = grep
#
# SunOS requires special grep for -e support
#
KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
LDFLAGS += -static -z muldefs
CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aio-linux.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cap.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-fork.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-handle.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-iosync.c \
	stress-io-uring.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-judy.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-l1cache.c \
	stress-landlock.c \
	stress-lease.c \
	stress-link.c \
	stress-list.c \
	stress-loadavg.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memhotplug.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-mincore.c \
	stress-misaligned.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmaphuge.c \
	stress-mmapmany.c \
	stress-mq.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-munmap.c \
	stress-nanosleep.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-pci.c \
	stress-personality.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-ping-sock.c \
	stress-pipe.c \
	stress-pipeherd.c \
	stress-pkey.c \
	stress-poll.c \
	stress-prctl.c \
	stress-prefetch.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-radixsort.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawpkt.c \
	stress-rawsock.c \
	stress-rawudp.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-reboot.c \
	stress-remap-file-pages.c \
	stress-rename.c \
	stress-resources.c \
	stress-revio.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rseq.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-secretmem.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-session.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigabrt.c \
	stress-sigchld.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-signal.c \
	stress-signest.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigtrap.c \
	stress-skiplist.c \
	stress-sleep.c \
	stress-smi.c \
	stress-sock.c \
	stress-sockabuse.c \
	stress-sockdiag.c \
	stress-sockfd.c \
	stress-sockpair.c \
	stress-sockmany.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-sysbadaddr.c \
	stress-sysinfo.c \
	stress-sysinval.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-tree.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-tun.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-unshare.c \
	stress-uprobe.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-utime.c \
	stress-vdso.c \
	stress-vecmath.c \
	stress-verity.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-addr.c \
	stress-vm-rw.c \
	stress-vm-segv.c \
	stress-vm-splice.c \
	stress-wait.c \
	stress-watchdog.c \
	stress-wcstr.c \
	stress-x86syscall.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \

#
# Stress core
#
CORE_SRC = \
	core-affinity.c \
	core-cache.c \
	core-cpu.c \
	core-hash.c \
	core-helper.c \
	core-ignite-cpu.c \
	core-io-priority.c \
	core-job.c \
	core-limit.c \
	core-log.c \
	core-madvise.c \
	core-mincore.c \
	core-mlock.c \
	core-mmap.c \
	core-module.c \
	core-mounts.c \
	core-mwc.c \
	core-net.c \
	core-out-of-memory.c \
	core-parse-opts.c \
	core-perf.c \
	core-sched.c \
	core-setting.c \
	core-shim.c \
	core-smart.c \
	core-thermal-zone.c \
	core-time.c \
	core-thrash.c \
	core-ftrace.c \
	core-try-open.c \
	core-vmstat.c \
	stress-ng.c

SRC = $(CORE_SRC) $(STRESS_SRC)
OBJS = $(SRC:.c=.o)

APPARMOR_PARSER=/sbin/apparmor_parser

all: makeconfig
	+$(MAKE) stress-ng VERBOSE=$(VERBOSE)

#
#  Load in and set flags based on config
#
-include config
CFLAGS += $(CONFIG_CFLAGS)
LDFLAGS += $(CONFIG_LDFLAGS)
OBJS += $(CONFIG_OBJS)

.SUFFIXES: .c .o

.o: Makefile

%.o: %.c stress-ng.h config.h git-commit-id.h
	$(Q)echo "CC $<"
	$(V)$(CC) $(CFLAGS) -c -o $@ $<

stress-ng: $(OBJS)
	$(Q)echo "LD $@"
	$(V)$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -o $@
	$(V)sync

config.h:
	+$(MAKE) -f Makefile.config STATIC=$(STATIC) -j

.PHONY:
makeconfig: config.h

#
#  generate apparmor data using minimal core utils tools from apparmor
#  parser output
#
apparmor-data.o: usr.bin.pulseaudio.eg
	$(V)$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin
	$(V)echo "#include <stddef.h>" > apparmor-data.c
	$(V)echo "char g_apparmor_data[]= { " >> apparmor-data.c
	$(V)od -tx1 -An -v < apparmor-data.bin | \
		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
		sed '$$ s/.$$//' >> apparmor-data.c
	$(V)echo "};" >> apparmor-data.c
	$(V)echo "const size_t g_apparmor_data_len = sizeof(g_apparmor_data);" >> apparmor-data.c
	$(Q)echo "CC $<"
	$(V)$(CC) -c apparmor-data.c -o apparmor-data.o
	$(V)rm -rf apparmor-data.c apparmor-data.bin

#
#  extract the PER_* personality enums
#
personality.h:
	$(V)$(CPP) $(CONFIG_CFLAGS) core-personality.c | $(GREP) -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
	| sed "s/.$$/,/" > personality.h
	$(Q)echo "MK personality.h"

stress-personality.c: personality.h

#
#  extract IORING_OP enums and #define HAVE_ prefixed values
#  so we can check if these enums exist
#
io-uring.h:
	$(V)$(CPP) $(CFLAGS) core-io-uring.c  | $(GREP) IORING_OP | sed 's/,//' | \
	sed 's/IORING_OP_/#define HAVE_IORING_OP_/' > io-uring.h
	$(Q)echo "MK io-uring.h"

stress-io-uring.c: io-uring.h

core-perf.o: core-perf.c core-perf-event.c
	$(V)$(CC) $(CFLAGS) -E core-perf-event.c | $(GREP) "PERF_COUNT" | \
	sed 's/,/ /' | sed s/'^ *//' | \
	awk {'print "#define _SNG_" $$1 " (1)"'} > core-perf-event.h
	$(Q)echo CC $<
	$(V)$(CC) $(CFLAGS) -c -o $@ $<

stress-vecmath.o: stress-vecmath.c
	$(Q)echo CC $<
	$(V)$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<

#
#  define STRESS_GIT_COMMIT_ID
#
git-commit-id.h:
	$(Q)echo "MK $@"
	@if [ -e .git/HEAD -a -e .git/index ]; then \
		echo "#define STRESS_GIT_COMMIT_ID \"$(shell git rev-parse HEAD)\"" > $@ ; \
	else \
		echo "#define STRESS_GIT_COMMIT_ID \"\"" > $@ ; \
	fi

$(OBJS): stress-ng.h Makefile

stress-ng.1.gz: stress-ng.1
	$(V)gzip -c $< > $@

.PHONY: dist
dist:
	rm -rf stress-ng-$(VERSION)
	mkdir stress-ng-$(VERSION)
	cp -rp Makefile Makefile.config $(SRC) stress-ng.h stress-ng.1 \
		core-personality.c core-io-uring.c \
		COPYING syscalls.txt mascot README.md \
		stress-af-alg-defconfigs.h README.Android test snap \
		TODO core-perf-event.c usr.bin.pulseaudio.eg \
		stress-version.h bash-completion example-jobs .travis.yml \
		kernel-coverage.sh code-of-conduct.txt stress-ng-$(VERSION)
	tar -Jcf stress-ng-$(VERSION).tar.xz stress-ng-$(VERSION)
	rm -rf stress-ng-$(VERSION)

.PHONY: pdf
pdf:
	man -t ./stress-ng.1 | ps2pdf - > stress-ng.pdf


.PHONY: clean
clean:
	$(V)rm -f stress-ng $(OBJS) stress-ng.1.gz stress-ng.pdf
	$(V)rm -f stress-ng-$(VERSION).tar.xz
	$(V)rm -f io-uring.h
	$(V)rm -f git-commit-id.h
	$(V)rm -f perf-event.h
	$(V)rm -f personality.h
	$(V)rm -f apparmor-data.bin
	$(V)rm -f *.o
	$(V)rm -f config config.h
	$(V)rm -f tags

.PHONY: fast-test-all
fast-test-all: all
	STRESS_NG=./stress-ng debian/tests/fast-test-all

.PHONY: lite-test
lite-test: all
	STRESS_NG=./stress-ng debian/tests/lite-test

.PHONY: slow-test-all
slow-test-all: all
	./stress-ng --seq 0 -t 15 --pathological --verbose --times --tz --metrics

.PHONY: tags
tags:
	ctags -R --extra=+f --c-kinds=+p *

.PHONY: install
install: stress-ng stress-ng.1.gz
	mkdir -p ${DESTDIR}${BINDIR}
	cp stress-ng ${DESTDIR}${BINDIR}
	mkdir -p ${DESTDIR}${MANDIR}
ifneq ($(MAN_COMPRESS),0)
	cp stress-ng.1.gz ${DESTDIR}${MANDIR}
else
	cp stress-ng.1 ${DESTDIR}${MANDIR}
endif
	mkdir -p ${DESTDIR}${JOBDIR}
	cp -rp example-jobs/*.job ${DESTDIR}${JOBDIR}
	mkdir -p ${DESTDIR}${BASHDIR}
	cp bash-completion/stress-ng ${DESTDIR}${BASHDIR}

=== debian/changelog ===
stress-ng (0.13.05-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: rename README to README.md in the make dist rule
  * Manual: update date
  * README.md: Add note to run make clean after git fetch
  * README.md: add some examples
  * README.md: Clean up white spaces in markup
  * README.md: add citations
  * README: Rename to README.me and add github style markdown
  * Revert "stress-aio-linux: clean up valgrind uninitialized memory
    warnings"
  * stress-dev: only define PPGETTIME{32|64} if PP_IOCT is defined
  * stress-ng.h: Fix missing \ in STRESS_PRAGMA_WARN_OFF macro
  * Revert "stress-cache: add clobbering warning pragma workaround"
  * stress-cache: add clobbering warning pragma workaround
  * stress-dev: don't declare stress_dev_scsi_generic_linux for
    non-linux targets
  * stress-dev: remove EMU debug message
  * stress-aio: clean async io cancel, check status with aio_error
  * stress-vm: clear up volatile discards warning with pedantic build
  * stress-kill: send signals to a child process to add more stress
  * stress-branch: double number of branch points, makes prediction
    harder for CPU
  * stress-vm: add mscan vm memory exercising method
  * stress-malloc: add yield point in stress_malloc_page_touch
  * stress-link: make reandom number index size_t
  * stress-get: initialize some objects to keep valgrind happy
  * stress-dirdeep: fix cleanup of dirent objects
  * stress-aio: add polled wait for completion
  * stress-aio-linux: clean up valgrind uninitialized memory warnings
  * stress-context: memset context requires and more sigaltstack
  * stress-hsearch: free hash items
  * core-smart: re-write begin/end checks
  * stress-thermal-zone: don't pass a null type to stress_tz_type_instance
  * Manual: clarify the semantics of the --timeout, -t option
  * stress-uprobe: ensure libc.so is also matched as a valid libc so name
  * Manual: remove GNU tbl extensions for table widths
  * stress-dev: exercise Linux scsi generic ioctls
  * stress-io-uring: keep track of unsupported opcodes
  * stress-fpunch: add yield check while populating test file
  * stress-io-uring: print opcode name to help decode opcode to human
    readable text
  * stress-dev: add parallel port ioctl device exercising
  * stress-io-uring: add statx and sync_file_range io-uring ops
  * stress-crypt: add some more crypto methods to exercise
  * stress-cpu-online: just limit to maximum of 65536 cpus
  * stress-context: rename __ prefix with suitable name
  * stress-context: remove empty line
  * core-thrash: add more slab work by attempting to shrink slabs
  * stress-dev: add hwrng exercising for linux
  * stress-dev: shuffle dev names rather than mixup sort
  * stress-dev: add Linux floppy disk ioctls to dev stressor
  * stress-iomix: add sync'ing on written data at most every second
  * Add new --no-oom-adjust option to disable all oom adjustments
  * core-out-of-memory: fix inverted check on oomable process
  * stress-ng: add missing ftrace and oomable options from --help output
  * snapcraft: change project repo URL

 -- Colin King <colin.king@canonical.com>  Mon, 11 Oct 2021 18:18:18 +0100

stress-ng (0.13.04-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-fallocate: Fix ENOENT failure messages
  * stress-sock: remove redundant variable msg_len
  * stress-dccp: remove redundant variable msg_len
  * stress-prefetch: add missing volatile in pointer cast
  * core-vmstat: optimization: remove check for non-null
  * core-vmstat: reduce scope of variable ret
  * stress-mergesort: don't jmp out of mergesort on NetBSD
  * stress-vm-segv: Fix weird hangs on DragonFlyBSD
  * stress-chmod: add EPERM check to systems that also support EFTYPE
  * stress-rmap: fix rmap bogo-ops threshold
  * Fix typo: HAVE_LOFF_T -> HAVE_OFF_T
  * Add off_t type detection and use it if loff_t is not defined
  * stress-prefetch: prefix macros with STRESS_ to avoid FreeBSD
    macro conflict
  * stress-prefetch: fix mmap/munmap type warnings on OpenHipster
  * stress-prefetch: use correct format specifier for size_t variable
    l3_data_mmap_size
  * stress-prefetch: add stress_void_ptr_put and use it to stash pointers
  * stress-prefetch: Add a L3 prefetch read benchmarking stressor
  * stress-fifo: exercise invalid mmap on fifo fd
  * stress-fifo: periodically exercise FIONREAD on read end of pipe
  * stress-fifo: periodically perform invalid lseek on pipe fd
  * stress-pthread: use phread_mutexattr calls to use priority
    inheritence
  * stress-misaligned: perform misaligned read/writes on page and cache
    boundaries

 -- Colin King <colin.king@canonical.com>  Tue, 28 Sep 2021 11:02:11 +0100

stress-ng (0.13.03-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-remap: Fix build failure on systems without MAP_POPULATE

 -- Colin King <colin.king@canonical.com>  Fri, 17 Sep 2021 12:33:12 +0100

stress-ng (0.13.02-1) unstable; urgency=medium

  [Fabien Malfoy]
  * core-helper: Quote the system-info.version value in YAML metrics
  [Danilo Krummrich]
  * core-vmstat: fix trim of devnames for nvme devices

  [Colin Ian King]
  * Makefile: bump version
  * Manual: update update contributors list and date
  * Signed-off-by: Colin Ian King <colin.king@canonical.com>
  * core-vmstat: make helper function static and constify arg
  * stress-opcode: clean up clang-11 pedantic build warning
  * stress-aio: perform retry if EBUSY occurs
  * stress-vm: constify end pointers
  * stress-stream: constify pointers idx1, idx2, idx3
  * stress-opcode: make pointer ops_end const
  * stress-msync: make pointer buf const
  * stress-mcontend: constify pointer vdata
  * stress-malloc: move scope of ptr and end, constify end
  * stress-malloc: make parameters counters const
  * Treewide: fix spelling mistakes and typos
  * stress-cpu: use the __builtin_parity function if it is available
  * core-vmstat: fix assignment that should be a comparison


=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               zlib1g-dev,
               libbsd-dev,
               libgcrypt20-dev,
               libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !linux-ia64],
               libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libipsec-mb-dev [amd64],
               libjudy-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libatomic1 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libkmod-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
Homepage: https://kernel.ubuntu.com/~cking/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.
